<?php
define('REGS_PAGINA','20');
require_once('./funciones.php');

function creaMenu($acciones, $menu) {
	$retval = '<li class="has-sub"><a href="#"><span>Acciones</span></a><ul>';
	foreach($acciones as $texto => $link) {
		$retval = $retval . '<li><a href="' . $link . '"><span>' . $texto . '</span></a></li>';
	}
	$retval = $retval . '</ul>';
	$retval = str_replace('<!--**acciones**-->', $retval, $menu);
	return $retval;
}

function getEnumeraciones( $table, $field, $dbcon)
{
	$qry = "SHOW COLUMNS FROM $table WHERE Field = '$field'";
	$result = $dbcon->query($qry);
	$fila = $result->fetch_row();
    $type = $fila[1];
    preg_match("/^enum\(\'(.*)\'\)$/", $type, $matches);
    $enum = explode("','", $matches[1]);
    return $enum;
}

/* Definición de datos de campo que viene en la descripción:
 * Si es un ID, de cajón lo ignoramos, por que es automático, aunque podemos saberlo si es autoincrement en la DB
 * Las enumeraciones se detecta automáticamente...
 * Ahora sí la estructura:
 * La descripción a mostrar...|modificadores
 * Modificadores posibles:
 * C [nombre,columna a mostrar] : Se toma de un catálogo, ejemplo: Unidad|C unidades,nombre. IMPORTANTE: Este modificador siempre debe estar al final...
 * T [nombre] : Forzar el tipo de control a [nombre], ejemplo: Es platillo?|T checkbox
 * D [valor] : Valor default del campo
 * O [función] : Evento onclick
 * M [función] : Evento onchange
 * P [función] : Evento onkeypress --Muy útil para validar al presionar una tecla...
 * H [número] : Altura ???
 * W [número] : anchura del control
 * S [clase] : Usar una clase de estilo especial
 * J [catalogo] : Usar un autocomplete de JQuery...
 * V [Tipo de campo] : Validaciones y máscaras 
 * 		@ Correo electrónico
 * 		T teléfono
 * 		N Numérico
 * 		
 * A [on|off] : Autocompletar activado o desactivado, por default activado...
 * Diferentes modificadores se agregan separados por barra |
 * 
 * ... y los que falten
 */

function generaCatalogo($tabla, $modo, $dbcon, $dbnom) {
    if ($dbcon == null) {
        $dbcon = conectaDB();
    }
	$retval = array();
	$strFila = '';
	$arrFila = array();
	$edCampos = '';
	$edLlave = '';
	$avalidar = array();
	$filaEstilo = '';
	$scrInserta = '';
	$qry = "show full columns in " . $tabla . ";";
	$rs = $dbcon->query($qry);
	$jquery = '';
	$elcampo = array();
	if ($modo == 'P') {
		while ($fila = $rs->fetch_row()) {
			if (!($fila[4] == 'PRI' && $fila[6] == 'auto_increment' || $fila[8] == '')) {
				$nomcampo = ofusca($tabla . '[' . $fila[0] . ']');
				$idcampo = ofusca($tabla . '_' . $fila[0]);
				$edCampos .= $fila[0] . ',';
				$descampo = $fila[8];
				$tipcampo = $fila[1];
				//No estamos usando el tipocampo, hay que parsearlo...
				$optcampo = explode('|', $fila[8]);
				$arrFila[$fila[0]] = array();
				$arrFila[$fila[0]]['etiqueta'] = $optcampo[0]; 
				$strFila = '<input name="' . $nomcampo . '" id="' . $idcampo . '" ';
				$retCampo = creaCampo($strFila, $optcampo, $nomcampo, $idcampo, $modo, $tipcampo, $jquery, $dbcon, $scrInserta);
                $strFila = $retCampo[0];
                $jquery = $retCampo[1];
                $scrInserta = $retCampo[2];

				//Metemos aqui la validación, después de construír el campo.
				if ($fila[3] == 'NO') {
					$avalidar[] = $fila[0];
				}
				$arrFila[$fila[0]]['control'] = $strFila;
				$strFila = "";
			} else if ($fila[4] == 'PRI') {
				//Vamos a generar un campo hidden para poner el ID de edición...
				$retval['llave'] = $fila[0];
			}
		}
		if ($jquery != '') {
			$arrFila['scripts'] = "<script>$(function() {" . $jquery . "});</script>";
		}
		$retval['controles'] = $arrFila;
		$retval['campos'] = $edCampos;
		$retval['avalidar'] = $avalidar;
	} else if ($modo = 'D') {
		//Catálogo secundario...
		//Tenemos que insertar los scripts
		$script = '<script type="text/javascript">
		function agregaFila(e, obj) {
			if (e == null || e.keyCode == 13) {
				if (e != null) e.preventDefault();
				var valido = true;';
		$scrValida = '';
		$strFila = '<table id="tbl' . $tabla . '" class="tabladetalle"><tr>';
		$cnt = 0;
		$enca = '';
		$ctrls = '<tr onkeypress="agregaFila(event, this);">';
		$llaves = '';
		while ($fila = $rs->fetch_row()) {
			$idcampo = $tabla . '_' . $fila[0];
			$tipcampo = $fila[1];
			if ($fila[8] != '') {
				$optcampo = explode('|', $fila[8]);
				$enca .= '<th>' . $optcampo[0] . '</th>';
				$ctrls .= '<td><input id="' . $idcampo . '" ';
				$scrInserta .= 'var cel' . $fila[0] . ' = fila.insertCell(' . $cnt. ');
				cel'. $fila[0] .'.innerHTML = document.getElementById("' . $idcampo .'").value + "<input type=\"hidden\" name=\"' . $tabla . '[fila" + tbl.rows.length + "][' . $fila[0] . ']\" value=\"" + document.getElementById("' . $idcampo . '").value + "\">';
				if (strpos($scrInserta, '**LLAVE**') === FALSE) {
					$scrInserta .= '**LLAVE**';
				}
				$scrInserta .= '";';
				$cnt ++;
				//construír el campo.
				$elcampo = creaCampo($ctrls, $optcampo, '', $idcampo, $modo, $tipcampo, $jquery, $dbcon, $scrInserta);
                $ctrls = $elcampo[0];
                $jquery = $elcampo[1];
                $scrInserta = $elcampo[2];
				if ($fila[3] == 'NO') {
					$scrValida .= "var el$fila[0] = document.getElementById('$idcampo');
					if (el$fila[0].value == '') {
						el$fila[0].style.background = '#ff0000';
						valido = false;
					}";
				}
				$ctrls .= '</td>';
			} else if ($fila[4] == 'PRI') {
				//Estas son las llaves... podemos usar
				$llaves .= '<input type=\"hidden\" name=\"' . $tabla . '[fila" + tbl.rows.length + "][' . $fila[0] . ']\" value=\"-1\" />';
			}
		}
		//Aquí es donde no consideré que hay veces que no hay jquery...
		if (isset($elcampo['jqcampo']) && $elcampo['jqcampo'] != '')
			$scrInserta = str_replace("value=\\\"\" + document.getElementById(\"$idcampo\").value", "value=\\\"\" + document.getElementById(\"jq$idcampo\").value", $scrInserta);

		$scrInserta = str_replace('**LLAVE**', $llaves, $scrInserta);
		$script .= $scrValida . 'if (valido) {
					tbl = document.getElementById("tbl' . $tabla . '");
					var fila = tbl.insertRow(tbl.rows.length);'
					. $scrInserta .
					'var cBorra = fila.insertCell(' . $cnt . ');
					cBorra.innerHTML = "<img src=\"./img/borrar.png\" onclick=\"quitadetalle(\'tbl' . $tabla . '\', this)\" />" ;
					limpiaDetalle(tbl.rows[1]);
				} else {
					alert("Por favor llene correctamente todo los datos...");
				}
			}
		}
		</script>';
		
		$enca .= '</tr>';
		$ctrls .= '<td onclick="agregaFila(null, this.parentNode);">agregar</td></tr>';
		$strFila .= $enca . $ctrls . '</table>';
		if ($jquery != '') {
			$strFila .= "<script>$(function() {" . $jquery . "});</script>";
		}
		$retval['forma'] = $script . $strFila;
	}
	$rs->free();
    /**** Desactivamos ésta función, ya nadie la usa
	//Traemos la descripción y nombre bonito del catálogo...
	$qry = "SELECT table_comment FROM INFORMATION_SCHEMA.TABLES WHERE table_schema='$dbnom' AND table_name='$tabla';";
	$result = $dbcon->query($qry);
	$fila = $result->fetch_row();
	$retval['nombre'] = substr($fila[0], 0, strpos($fila[0], '|'));
	$retval['descripcion'] = substr($fila[0], strpos($fila[0], '|') + 1);
    $result->free();
     *      * 
     */
	return $retval;
}

function generaTabla($arrCampos, $modo) {
	//Solamente generamos el antiguo modo de tabla, es una especie de compatibilidad backwards...
	$retval = "";
	if ($modo == 'P') {
		//var_dump($arrCampos);
		foreach ($arrCampos as $key => $value) {
			if ($key != 'scripts') {
				$retval .= '<tr><td>' . $value['etiqueta'] . '</td><td>' . $value['control'] . '</td></tr>';
			} else {
				$retval .= $value;
			}
		}
	} else if ($modo == 'D') {
		
	}
	return $retval;
}

function generaScripts($tabla, $edLlave, $edCampos, $avalidar) {
	$retval = '<script type="text/javascript">
		function quitadetalle(tabla, fila) {
			var tbl = document.getElementById(tabla);
			tbl.deleteRow(fila.parentElement.parentElement.rowIndex);
		}
		
		function borra(datos) {
			if (confirm("¿Seguro desea borrar este registro?")) {
			    var datos = {ae: datos, r: "n"};
                $.ajax({
                    url: "./motores/hanumat.php",
                    type: "POST",
                    dataType: "JSON",
                    data: datos
                }).done(function (r) {
                    if (r.error == "0") {
                        location.reload();
                    }
                });
				window.location="./motores/doCatalogo.php?aeditar=2" + datos;
			}
		}
		
		function edita(id) {
			$("#ae").val('.ofusca("1{$edLlave}") . '|"+id);
            var datos = {t: "' . ofusca($tabla) . '",l: "' . ofusca(substr($edCampos, 0, -1)) . '", c: "' . ofusca($edLlave) . '|" + id, r: "e"};
            $.ajax({
                url: "./motores/hanumat.php",
                type: "POST",
                dataType: "JSON",
                data: datos
            }).done(function (r) {
                if (r.error == "0") {
                    for (var campo in r) {
                        if (r.hasOwnProperty(campo) && campo != "error") {
                            document.getElementById(campo).value = r[campo];
                        }
                    }
                } else {
                    alert(r.errmsg);
                }
            });
		}
		
		function valida() {
			var valido = true;';
	foreach ($avalidar as $campo) {
	    $hCampo = ofusca($tabla . "_$campo");
		$retval .= "var v_$campo = document.getElementById('{$hCampo}');";
		$retval .= "if (v_$campo.value == '') {
				v_$campo.style.background = '#FF0000';
				valido = false;
			}";
	}
	$retval .= "if (!valido) {
				event.preventDefault();
				alert('complete los datos faltantes, por favor');
			}
		}
		
		function limpia() {
			document.getElementById('frmAlta').reset();
		}
	</script>";
	return $retval;
}

function creaPaginador($tabla, $dbcon, $condicion = "") {
	$retval = '<tr>';
	if ($condicion != "") $condicion = " where " . resuelveCond($condicion);
	$qry = "select count(*) from vc_$tabla $condicion;";
	$result = $dbcon->query($qry) or die($qry);
	$cnt = $result->fetch_row();
	$total = $cnt[0];
	$pags = ceil($total / REGS_PAGINA);
	for ($p = 0; $p < $pags; $p++) {
		$retval .= '<td><a href="javascript:void(0);" onclick="busca(' . $p . ')">' . ($p + 1) . '</a></td>';
	}
	$retval .= '</tr>';
	return $retval;
}

function generaVista($tabla, $edLlave, $dbcon, $condicion = "", $pag = 0) {
    //Esta función debe de cambiar por una consulta ajax desde el cliente...
    
	$retval = '<tr>';
	$pag = $pag * REGS_PAGINA;
	if ($condicion != "") $condicion = " where " . resuelveCond($condicion);
	$qry="select * from vc_$tabla $condicion limit $pag, " . REGS_PAGINA . ";";
	//FIXIT quitar el query del die
	$result=$dbcon->query($qry) or die ($qry);
	$cols = $result->fetch_fields();
	$primera = TRUE;
	foreach ($cols as $laCol) {
	    if ($primera) {
	        $primera = false;
	    } else {
	        $retval .= '<th>'. $laCol->name .'</th>';
	    }
	    
	}
	$retval .= '<th>Opciones</th></tr>';
    $retval .= '</tr>';
	while($fila = $result->fetch_row()) {
		$retval .= '<tr>';
		for ($c = 0; $c < $result->field_count; $c++) {
			switch ($c) {
				case 0:
					$retval .= '<td style="display: none;">'. $fila[$c] .'</td>';
					break;
				case 1:
					$retval .= '<td><a href="javascript:void(0)" onclick="edita(\''. $fila[0] .'\')">'. $fila[$c] .'</a></td>';
                    //$retval .= '<td><a href="#task-modal" class="task-add modal-trigger waves-effect waves-light" style="table-layout: fixed;" onclick="edita(\''. $fila[0] .'\')">'. $fila[$c] .'</a></td>';
					break;
				default:
					$retval .= '<td>'. $fila[$c] .'</td>';
					break;
			}
		}
		//Tenemos aquí que tener en cuenta que la fila[0] siempre sea el ID de la fila...
		$retval .= '<td><input type="image" src="./images/borrar.png" onclick="borra(\'' . ofusca("2$edLlave") . '|' . ofusca($fila[0]) . '|'. ofusca($tabla) . ')" /></td></tr>';
        $retval .= '</tr>';
	}
	return $retval;
}

function creaJQueryAC($control, $tabla, $campos) {
//	<script>
//		$(function() {
	$retval = "$( '#$control' ).autocomplete({
				source: './dameauto.php?tbl=$tabla&cam=$campos',
				minLength: 3,
				focus: function (event, ui){
					event.preventDefault();
					$(this).val(ui.item.label);
				},
				select: function(event, ui) {
					event.preventDefault();
					$('#jq$control').val(ui.item.value);
				}
			});";
//		});
//	</script>
	return $retval;
}

function creaJQueryDT($control, $minimo, $maximo) {
	$retval = "$(function() {
		$.datepicker.regional['es'] = {
			closeText: 'Cerrar',
			prevText: '<Ant',
			nextText: 'Sig>',
			currentText: 'Hoy',
			monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
			monthNamesShort: ['Ene','Feb','Mar','Abr', 'May','Jun','Jul','Ago','Sep', 'Oct','Nov','Dic'],
			dayNames: ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
			dayNamesShort: ['Dom','Lun','Mar','Mié','Juv','Vie','Sáb'],
			dayNamesMin: ['Do','Lu','Ma','Mi','Ju','Vi','Sá'],
			weekHeader: 'Sm',
			dateFormat: 'dd/mm/yy',
			firstDay: 1,
			isRTL: false,
			showMonthAfterYear: false,
			yearSuffix: ''
		};
	    $.datepicker.setDefaults($.datepicker.regional['es']);
		$( '#$control' ).datepicker({
			dateFormat: 'yy-mm-dd', minDate: '$minimo', maxDate: '$maximo',
			changeMonth: true,
			changeYear: true
		});
	});";
	return $retval;
}

function creaCampo($retval, $optcampo, $nomcampo, $idcampo, $modo, $tipcampo, $jquery, $dbcon, $scrInserta) {
	$jq_campo = '';
	$filaEstilo = '';
	$arregloCampo = array();
	for ($i = 1; $i < count($optcampo); $i++) {
		$elval = substr($optcampo[$i], 2);
		switch (substr($optcampo[$i], 0, 1)) {
			case 'C':
				if ($modo == 'P') {
					$retval = str_replace('input name="' . $nomcampo, 'select name="' . $nomcampo, $retval) . '"><option>--Seleccione uno--</option>**F****S**';
				} else if ($modo == 'D') {
					$retval = str_replace('input id="' . $idcampo, 'select id="' . $idcampo, $retval) . '"><option>--Seleccione uno--</option>**F****S**';
				}
				$opts = explode(',', $elval);
				//Tenemos que poner la tabla...
				if (count($opts) == 2) {
				    $qryOpts = "select id, $opts[1] from $opts[0] order by $opts[1];";
				} else {
				    $qryOpts = "select $opts[1], $opts[2] from $opts[0] order by $opts[2];";
				}
				
				if ($result = $dbcon->query($qryOpts)) {
                    while ($row = $result->fetch_row()) {
                        $retval .= '<option value="' . $row[0] . '">' . $row[1] . '</option>';
                    }
                    $result->free();
				} else {
				    error_log("No pudo traer tabla externa con: $qryOpts");
				}
				break;
			case 'T':
				if ($elval == 'textarea') {
					if ($modo == 'P') {
						$retval = str_replace('input name="' . $nomcampo, '**T**textarea name="' . $nomcampo, $retval);
					} else if ($modo == 'D') {
						$retval = str_replace('input id="' . $idcampo, '**T**textarea id="' . $idcampo, $retval);
					}
				} else {
					$retval .= 'type = "' . $elval . '" ';
				}
				$retval .= '**F**';
				break;
			case 'D':
				$retval .= 'value = "' . $elval . '" ';
				break;
			case 'O':
				$retval .= 'onclick="' . $elval . '" ';
				break;
			case 'M':
				$retval .= 'onchange="' . $elval . '" ';
				break;
			case 'H':
				$filaEstilo .= 'height: ' . $elval . 'px; ';
				break;
			case 'W':
				$filaEstilo .= 'width: ' . $elval . 'px; ';
				break;
			case 'S':
				$retval .= 'class="'. $elval . '" ';
				break;
			case 'J':
				$opts = explode(',', $elval, 2);
				$jquery .= creaJQueryAC($idcampo,  $opts[0], $opts[1]);
				$retval .= 'type = "text"**F**';
				$jq_campo = '<input type="hidden" id="jq' . $idcampo . '" />';
				break;
			case 'P':
				$retval .= 'onkeypress="' . $elval . '" ';
				break;
			case 'A':
				$retval .= 'autocomplete="'.$elval.'"';
				break;
		}
	}
	if (strpos($retval, '**F**') > 0) {
		$retval = str_replace('**F**', '', $retval);
	} else {
		if (substr($tipcampo, 0, 3) == 'int' || substr($tipcampo, 0, 7) == 'tinyint') {
			$retval .= 'type="number" ';
		} else if (substr($tipcampo, 0, 7) == 'varchar') {
			$retval .= 'type="text" maxlength="' . substr($tipcampo, strpos($tipcampo, '(') + 1, -1) . '" ';
		} else if (substr($tipcampo, 0, 4) == 'text') {
			if ($modo == 'P') {
				$retval = str_replace('input name="' . $nomcampo, '**T**textarea name="' . $nomcampo, $retval);
			} else if ($modo == 'D') {
				$retval = str_replace('input id="' . $idcampo, '**T**textarea id="' . $idcampo, $retval);
			}
		} else if (substr($tipcampo, 0, 4) == 'enum') {
			//Vamos a traernos las enumeraciones...
			if ($modo == 'P') {
				$retval = str_replace('input name="' . $nomcampo, 'select name="' . $nomcampo, $retval) . '"><option>--Seleccione uno--</option>**S**';
			} else if ($modo == 'D') {
				$retval = str_replace('input id="' . $idcampo, 'select id="' . $idcampo, $retval) . '"><option>--Seleccione uno--</option>**S**';
			}
			preg_match("/^enum\(\'(.*)\'\)$/", $tipcampo, $matches);
			$enum = explode("','", $matches[1]);
			foreach ($enum as $value) {
				$retval .= '<option value="' . $value . '">' . $value . '</option>';
			}
		} else if ($tipcampo == 'char(1)') {
			$retval .= 'type="checkbox" value="1"';
		} else if ($tipcampo == 'datetime' || $tipcampo == 'date') {
			$retval .= 'type="datetime-local"';
        } else if ($tipocampo == 'time') {
            $retval .= 'type="time" ';
        }
	}
	if ($filaEstilo != '') {
		$retval .= 'style="' . $filaEstilo . '" ';
		$filaEstilo = '';
	}
	if (strpos($retval, '**T**')) {
		$retval = str_replace('**T**', '', $retval);
		$retval .= '></textarea>';
	} else if (strpos($retval, '**S**')) {
		$retval = str_replace('**S**', '', $retval);
		$retval .= '</select>';
	} else {
		$retval .= '/>';
	}
    array_push($arregloCampo, $retval);
    array_push($arregloCampo, $jquery);
    array_push($arregloCampo, $scrInserta);
    //array_push($arregloCampo, $retval2);
    
    return $arregloCampo;
	
	//$retval2 = array('jqcampo' => $jq_campo);
	//return $retval2;
}
?>
